# Collect a posted debit memo Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. This API operation provides an easy way to let the client-side to collect an existing posted debit memo. It supports the following steps: 1. Apply unapplied credit memos to the posted debit memo by Oldest-First-Largest-First rule if there are more than one unapplied credit memos. 2. Apply unapplied payments to the posted debit memo by Oldest-First-Largest-First rule if there are more than one unapplied payments. 3. Process payment to the posted debit memo if there is an open-balance on it. Restrictions Since this API will do lots of works, and some of them are resource consuming, we need to restrict the usage of this API by the following conditions: 1. If the target debit memo gets more than 10 debit memo items, the request will be rejected. 2. If CreditMemo is specified in applicationOrder, when there are more than 25 credit memos will be used to apply to the debit memo, the request will be rejected. 3. If CreditMemo is specified in applicationOrder, when there are more than 100 credit memo items will be used to apply to the debit memo, the request will be rejected. 4. If UnappliedPayment is specified in applicationOrder, when there are more than 25 payments will be used to apply to the debit memo, the request will be rejected. Endpoint: POST /v1/debit-memos/{debitMemoKey}/collect Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Idempotency-Key` (string) Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident. - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) The minor API version. For a list of available minor versions, see API upgrades. ## Path parameters: - `debitMemoKey` (string, required) The ID or number of a posted debit memo. For example, 8a8082e65b27f6c3015ba419f3c2644e. ## Request fields (application/json): - `applicationOrder` (array) The priority order to apply credit memos and/or unapplied payments to the debit memo. Possible item values are: CreditMemo, UnappliedPayment. Note: - This field is valid only if the applyCredit field is set to true. - If no value is specified for this field, the default priority order is used, ["CreditMemo", "UnappliedPayment"], to apply credit memos first and then apply unapplied payments. - If only one item is specified, only the items of the spedified type are applied to invoices. For example, if the value is ["CreditMemo"], only credit memos are used to apply the debit memo. - `applyCredit` (boolean) Whether to automatically apply credit memos or unapplied payments, or both to the debit memo. If the value is true, the credit memo or unapplied payment, or both will be automatically applied to the debit memo. If no value is specified or the value is false, no action is taken. Example: true - `collect` (boolean) Indicates if the current request needs to collect payment or not. Example: true - `payment` (object) Some detail info that would be used to processed an electronic payment. The info would only effect when collect set to true. - `payment.gatewayId` (string) The ID of the gateway instance that processes the payment. The ID must be a valid gateway instance ID and this gateway must support the specific payment method. If no gateway ID is specified in the request body, the default gateway for the customer account is used automatically, if this default one is not configured, the default gateway of the tenant would be used. - `payment.paymentMethodId` (string) The unique ID of the payment method that the customer used to make the payment. If no payment method ID is specified in the request body, the default payment method for the customer account is used automatically. If the default payment method is different from the type of payments that you want to create, an error occurs. ## Response 200 fields (application/json): - `appliedCreditMemos` (array) The information about which credit memo applied to the specific debit memo. - `appliedCreditMemos.appliedAmount` (number) The applied amount of the credit memo to the debit memo. - `appliedCreditMemos.id` (string) The unique ID of the credit memo. - `appliedCreditMemos.number` (string) The unique identification number of the credit memo. - `appliedCreditMemos.unappliedAmount` (number) The unapplied amount of the credit memo after applied to the debit memo. - `appliedPayments` (array) The information about which payment applied to the specific debit memo. - `appliedPayments.appliedAmount` (number) The applied amount of the payment to the debit memo. - `appliedPayments.id` (string) The unique ID of the payment. - `appliedPayments.number` (string) The unique identification number of the payment. - `appliedPayments.unappliedAmount` (number) The unapplied amount of the payment after applied to the debit memo. - `debitMemo` (object) The information about the debit memo that just collected. - `debitMemo.id` (string) The unique ID of the debit memo. - `debitMemo.number` (string) The unique identification number of the debit memo. - `organizationLabel` (string) The organization that this object belongs to. Note: This field is available only when the Multi-Org feature is enabled. - `processedPayment` (object) The information about the payment that newly processed to the debit memo. - `processedPayment.amount` (number) The total amount of the payment. - `processedPayment.gatewayId` (string) The ID of the gateway instance that processes the payment. - `processedPayment.gatewayResponse` (string) The message returned from the payment gateway for the payment. This message is gateway-dependent. - `processedPayment.gatewayResponseCode` (string) The code returned from the payment gateway for the payment. This code is gateway-dependent. - `processedPayment.id` (string) The unique ID of the created payment. For example, 4028905f5a87c0ff015a87eb6b75007f. - `processedPayment.number` (string) The unique identification number of the payment. For example, P-00000001. - `processedPayment.paymentMethodId` (string) The unique ID of the payment method that the customer used to make the payment. - `processedPayment.status` (string) The status of the payment. Enum: "Processing", "Processed", "Error", "Canceled" - `success` (boolean) Returns true if the request was processed successfully. ## Response 500 fields (application/json): - `reasons` (array) Example: [{"code":"ObjectNotFound","message":"Notification definition with id 6e569e1e05f040eda51a927b140c0ac1 does not exist"}] - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response ## Response 4XX fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded.